rm(list = ls())
library(data.table)
library(dplyr)
library(tidyr)
library(survival)
# path = "/Users/jianchen/Library/CloudStorage/Dropbox/Yang/UNC/covid_optimal_booster/Results/output_age65+_0"
# load("../../prediction/for_bios/entry_time_age65+.RData")

load("../entry_time_age65+_dth.RData")
filename = dir("../output_age65+_0_dth")

get_curve_svr = function(pred_svr, label){
  dat = data.frame(id = pred_svr$id,
                   start = entry.time$entry.time,
                   stop = pred_svr$svr.infection.time,
                   status = ifelse(pred_svr$svr.infection.time < tau, 1, 0))
  E = entry.time$entry.time[match(dat$id, entry.time$id)]
  dat$start = dat$start - E
  dat$stop = dat$stop - E
  
  res = coxph(Surv(start, stop, status) ~ 1, data=dat)
  fit <- summary(survfit(res))
  dat_ret = data.frame(t = fit$time, Haz = -log(fit$surv), 
                       lower = -log(fit$upper), upper = -log(fit$lower), group = label)
  
  dat_tmp = data.frame(t = 0:750, Haz = rep(0, 751), group = label)
  dat_tmp$Haz = dat_ret$Haz[match(dat_tmp$t, dat_ret$t)]
  dat_tmp$Haz[1] = 0
  index_missing = which(is.na(dat_tmp$Haz))
  if(length(index_missing) > 0) {
    for (i in 1:length(index_missing)) {
      dat_tmp$Haz[index_missing[i]] = dat_tmp$Haz[index_missing[i] - 1]
    }
  }
  
  return(dat_tmp)
}

tau = 792
entry.time = data.frame(id = 1:length(VacTime), entry.time = VacTime)

dat_plot_dth0 = data.frame(t = 0:750, Haz = rep(0, 751), group = "Non-boosted")
for (k in filename) {
  cat("k =", which(filename == k), "\n")
  load(file = paste("../output_age65+_0_dth/", k, sep = ""))

  # Death
  dat_dth0 = get_curve_svr(pred0_svr, "Non-boosted")
  dat_plot_dth0$Haz = dat_plot_dth0$Haz + dat_dth0$Haz
}
dat_plot_dth0$Haz = dat_plot_dth0$Haz / length(filename)

save(dat_plot_dth0, file = "plot_age65+_0_dth.RData")




