rm(list = ls())
library(data.table)
library(RcppArmadillo)
library(dplyr)
library(Rcpp)
Sys.setenv("PKG_CXXFLAGS" = "-fopenmp")
Sys.setenv("PKG_LIBS" = "-fopenmp")
# setwd("/Users/jianchen/Library/CloudStorage/Dropbox/Yang/UNC/covid_optimal_booster/prediction/original/prediction_general_age65+")
# load("../big_model_general_infection_age65+/dat_general_infection_age65+.RData")
# sourceCpp("../prediction_general.cpp")
# sourceCpp("../computeList.cpp")
# load("../big_model_general_infection_age65+/res_big_model_general_infection.RData")

load("../../big_model_general_infection_age65+/res_big_model_general_infection_age65+.RData")
load("../../big_model_general_infection_age65+/dat_general_infection_age65+.RData")
load("U.RData")
sourceCpp("../../prediction_general_parallel.cpp")
sourceCpp("../../computeList.cpp")

predict.general = function(survData){
  survData_tmp = survData
  survData_tmp = merge(survData_tmp, comb1, 
                       by = c("booster1.manu", "booster1.cohort", "booster1.type"), 
                       all = FALSE, sort = FALSE)
  
  survData_tmp = merge(survData_tmp, comb2, 
                       by = c("booster2.manu", "booster2.cohort", "booster2.type"), 
                       all = FALSE, sort = FALSE)
  
  survData_tmp = merge(survData_tmp, comb3, 
                       by = c("booster3.manu", "booster3.cohort", "booster3.type"), 
                       all = FALSE, sort = FALSE)
  
  S_booster1 = survData_tmp$booster1.date
  V_booster1 = survData_tmp$type.num1
  S_booster2 = survData_tmp$booster2.date
  V_booster2 = survData_tmp$type.num2
  S_booster3 = survData_tmp$booster3.date
  V_booster3 = survData_tmp$type.num3
  
  S = computeList(as.list(S_booster1), as.list(S_booster2), (1:n)-1)
  S = computeList(S, as.list(S_booster3), (1:n)-1)
  V = computeList(as.list(V_booster1), as.list(V_booster2), (1:n)-1)
  V = computeList(V, as.list(V_booster3), (1:n)-1)
  rm(S_booster1, V_booster1, S_booster2, V_booster2, S_booster3, V_booster3)
  
  pred_res = predict_infection(result$beta, result$gamma, lambda, t, 
                               V, S, X, booster.num, endpt, knots, constantVE, 
                               dimension, infection_ind, VacTime, U)
  pred = data.frame(id = pred_res$id, infection.time = pred_res$infection_time)
  
  return(pred)
}

t = NULL
lambda = NULL
t_ref = min(VacTime):(tau+1)
for (i in 1:length(t_ref)) {
  t[i] = t_ref[i]
  ind = which(result$time == t_ref[i])
  lambda[i] = ifelse(length(ind) > 0, result$lambda[ind], 0)
}

## 15 months
survData1 = survData_uni %>%
  mutate(booster1.date = pmin(entry.time + 450 + round(runif(n = nrow(survData_uni), min = -30, max = 30)), tau),
         booster1.cohort = cut(booster1.date, breaks = cohort_cutoff1),
         booster1.type = ifelse(booster1.date >= 630, "Biva", "Mono"),
         booster2.date = tau,
         booster2.cohort = cut(booster2.date, breaks = cohort_cutoff2),
         booster2.type = ifelse(booster2.date >= 630, "Biva", "Mono"),
         booster3.date = tau,
         booster3.cohort = cut(booster3.date, breaks = cohort_cutoff3),
         booster3.type = ifelse(booster3.date >= 630, "Biva", "Mono"))
pred1 = predict.general(survData1)
rm(survData1)

save(pred1, id_all, file = "pred_general_age65+_1.RData")


