rm(list = ls())
library(data.table)
library(RcppArmadillo)
library(dplyr)
library(Rcpp)
# setwd("/Users/jianchen/Library/CloudStorage/Dropbox/Yang/UNC/covid_optimal_booster/Results")
# load("pred_general.RData")
# load("res_big_model_severe_infection.RData")
# load("../prediction/tab_all_processed.RData")
# sourceCpp("../computeList.cpp")
# sourceCpp("../prediction/prediction_severe.cpp")

load("../prediction_general_age65+/pred_general_age65+_1.RData")
load("../../big_model_severe_infection_age65+/res_big_model_severe_infection_age65+.RData")
load("../../big_model_severe_infection_age65+/dat_severe_infection_age65+.RData")
load("U.RData")
sourceCpp("../../prediction_severe_parallel.cpp")
sourceCpp("../../computeList.cpp")

ind = which(id_all %in% survData_uni$cluster_id)
pred1_res = pred1[ind,]

predict.severe = function(survData, pred){
  survData_tmp = survData
  survData_tmp = merge(survData_tmp, comb1, 
                       by = c("booster1.manu", "booster1.cohort", "booster1.type"), 
                       all = FALSE, sort = FALSE)
  
  survData_tmp = merge(survData_tmp, comb2, 
                       by = c("booster2.manu", "booster2.cohort", "booster2.type"), 
                       all = FALSE, sort = FALSE)
  
  survData_tmp = merge(survData_tmp, comb3, 
                       by = c("booster3.manu", "booster3.cohort", "booster3.type"), 
                       all = FALSE, sort = FALSE)
  
  S_booster1 = survData_tmp$booster1.date
  V_booster1 = survData_tmp$type.num1
  S_booster2 = survData_tmp$booster2.date
  V_booster2 = survData_tmp$type.num2
  S_booster3 = survData_tmp$booster3.date
  V_booster3 = survData_tmp$type.num3
  
  S = computeList(as.list(S_booster1), as.list(S_booster2), (1:n)-1)
  S = computeList(S, as.list(S_booster3), (1:n)-1)
  V = computeList(as.list(V_booster1), as.list(V_booster2), (1:n)-1)
  V = computeList(V, as.list(V_booster3), (1:n)-1)
  rm(S_booster1, V_booster1, S_booster2, V_booster2, S_booster3, V_booster3)
  
  for (k in 1:4) {
    cat("k = ", k, "\n")
    S_tmp = pmin(pred[,k+1], tau)
    V_tmp = as.numeric(cut(S_tmp, breaks = c(-Inf, endpt, Inf), labels = 1:nmos)) + n_cohort
    S = computeList(S, as.list(S_tmp), (1:n)-1)
    V = computeList(V, as.list(V_tmp), (1:n)-1)
  }
  
  pred_res = predict_infection(result$beta, result$gamma, lambda, t, 
                               V, S, X, booster.num, endpt, knots, constantVE, 
                               dimension, infection_ind, VacTime, U)
  pred_svr = data.frame(id = pred_res$id, svr.infection.time = pred_res$infection_time)
  
  return(pred_svr)
}
#save(VacTime, file = "../prediction/entry_time.RData")

t = NULL
lambda = NULL
t_ref = min(VacTime):(tau+1)
for (i in 1:length(t_ref)) {
  t[i] = t_ref[i]
  ind = which(result$time == t_ref[i])
  lambda[i] = ifelse(length(ind) > 0, result$lambda[ind], 0)
}
##################################################################################################################################
## 15 months
survData1 = survData_uni %>%
  mutate(booster1.date = pmin(entry.time + 450 + round(runif(n = nrow(survData_uni), min = -30, max = 30)), tau),
         booster1.cohort = cut(booster1.date, breaks = cohort_cutoff1),
         booster1.type = ifelse(booster1.date >= 630, "Biva", "Mono"),
         booster2.date = tau,
         booster2.cohort = cut(booster2.date, breaks = cohort_cutoff2),
         booster2.type = ifelse(booster2.date >= 630, "Biva", "Mono"),
         booster3.date = tau,
         booster3.cohort = cut(booster3.date, breaks = cohort_cutoff3),
         booster3.type = ifelse(booster3.date >= 630, "Biva", "Mono"))
pred1_svr = predict.severe(survData1, pred1_res)
rm(survData1)

save(pred1, pred1_svr, file = paste("pred_severe_age65+_1_simu", seed, ".RData", sep = ""))


